package GenerischeKlassen;

public class BaumElement<E> {

	public BaumElement<E> left;
	public E data;
	public BaumElement<E> right;

	public BaumElement(BaumElement<E> l, E d, BaumElement<E> r){
		left = l;
		data = d;
		right = r;
	}

	public int height(){
		if (left == null && right == null) return 1;
		else if (left == null) return 1 + right.height();
		else if (right == null) return 1 + left.height();
		else if (left.height() > right.height()) return 1 + left.height();
		else return 1 + right.height(); 
	}
	
	public void insert(E s){
		if (s.toString().compareTo(data.toString())>0 && right==null) right = new BaumElement<E>(null, s, null);
		else if (s.toString().compareTo(data.toString())>0 ) right.insert(s);
		else if (left==null) left = new BaumElement<E>(null, s, null);
		else left.insert(s);
	}
	
	public String toString(){
		if (left == null && right == null) return data.toString();
		else if (left == null) return data + " " + right.toString();
		else if (right == null) return left.toString() + " " + data;
		else  return left.toString() + " " + data + " " + right.toString();
	}

}
